From 6fdc617a876bf0c7c81cdbbba289892670a16783 Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Wed, 22 May 2019 02:17:11 -0400
Subject: [PATCH 03/31] overhaul of ReplicationStreamMessage to make the object
 form of the packet less of a hassle to compose; updated tests for RSM

---
 .../game/ReplicationStreamMessage.scala       | 934 ++++++++++--------
 .../game/ReplicationStreamMessageTest.scala   | 523 ++++------
 .../src/main/scala/WorldSessionActor.scala    |   4 +-
 3 files changed, 698 insertions(+), 763 deletions(-)

diff --git a/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala b/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala
index 0f4aafc3..233f5a59 100644
--- a/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/ReplicationStreamMessage.scala
@@ -5,90 +5,82 @@ import net.psforever.newcodecs.newcodecs
 import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
 import scodec.{Attempt, Codec, Err}
 import scodec.codecs._
-import shapeless.{::, HNil}
+import shapeless.HNil //DO NOT IMPORT shapeless.:: HERE; it interferes with required scala.collection.immutable.::
+
+import scala.annotation.tailrec
 
 /**
-  * Maintains squad information changes performed by this listing.
+  * Maintain squad information for a given squad's listing.
   * Only certain information will be transmitted depending on the purpose of the packet.
-  * @param leader the name of the squad leader as a wide character string, or `None` if not applicable
-  * @param task the task the squad is trying to perform as a wide character string, or `None` if not applicable
-  * @param zone_id the continent on which the squad is acting, or `None` if not applicable
-  * @param size the current size of the squad, or `None` if not applicable;
-  *             "can" be greater than `capacity`, though with issues
-  * @param capacity the maximum number of members that the squad can tolerate, or `None` if not applicable;
+  * @param leader the name of the squad leader, usually the first person in the squad member list;
+  *               `None` if not applicable
+  * @param task the task the squad is trying to perform as a wide character string;
+  *             `None` if not applicable
+  * @param zone_id the continent on which the squad is acting;
+  *                `None` if not applicable
+  * @param size the current size of the squad;
+  *             "can" be greater than `capacity`, though with issues;
+  *             `None` if not applicable
+  * @param capacity the maximum number of members that the squad can tolerate;
   *                 normal count is 10;
-  *                 maximum is 15 but naturally can not be assigned that many
-  * @param squad_guid a GUID associated with the squad, used to recover the squad definition, or `None` if not applicable;
-  *                   sometimes it is defined but is still not applicable
+  *                 maximum is 15 but naturally can not be assigned that many;
+  *                 `None` if not applicable
+  * @param squad_guid a GUID associated with the squad, used to recover the squad definition;
+  *                   sometimes it is defined but is still not applicable;
+  *                   `None` if not applicable (rarely applicable)
   */
 final case class SquadInfo(leader : Option[String],
                            task : Option[String],
                            zone_id : Option[PlanetSideZoneID],
                            size : Option[Int],
                            capacity : Option[Int],
-                           squad_guid : Option[PlanetSideGUID] = None)
+                           squad_guid : Option[PlanetSideGUID] = None) {
+  /**
+    * Populate the undefined fields of this object with the populated fields of a second object.
+    * If the field is already defined in this object, the provided object does not contribute new data.
+    * @param info the `SquadInfo` data to be incorporated into this object's data
+    * @return a new `SquadInfo` object, combining with two objects' field data
+    */
+  def And(info : SquadInfo) : SquadInfo = {
+    SquadInfo(
+      leader.orElse(info.leader),
+      task.orElse(info.task),
+      zone_id.orElse(info.zone_id),
+      size.orElse(info.size),
+      capacity.orElse(info.capacity),
+      squad_guid.orElse(info.squad_guid)
+    )
+  }
+}
 
 /**
-  * Define three fields determining the purpose of data in this listing.<br>
-  * <br>
-  * The third field `unk3` is not always be defined and will be supplanted by the squad (definition) GUID during initialization and a full update.<br>
-  * <br>
-  * Actions:<br>
-  * `unk1&nbsp;unk2&nbsp;&nbsp;unk3`<br>
-  * `0&nbsp;&nbsp;&nbsp;&nbsp;true&nbsp;&nbsp;4 -- `Remove a squad from listing<br>
-  * `128&nbsp;&nbsp;true&nbsp;&nbsp;0 -- `Update a squad's leader<br>
-  * `128&nbsp;&nbsp;true&nbsp;&nbsp;1 -- `Update a squad's task or continent<br>
-  * `128&nbsp;&nbsp;true&nbsp;&nbsp;2 -- `Update a squad's size<br>
-  * `129&nbsp;&nbsp;false&nbsp;0 -- `Update a squad's leader or size<br>
-  * `129&nbsp;&nbsp;false&nbsp;1 -- `Update a squad's task and continent<br>
-  * `131&nbsp;&nbsp;false&nbsp;X -- `Add all squads during initialization / update all information pertaining to this squad
-  * @param unk1 na
-  * @param unk2 na
-  * @param unk3 na;
-  *             not always defined
-  * @param info information pertaining to this squad listing
-  */
-//TODO when these unk# values are better understood, transform SquadHeader to streamline the actions to be performed
-final case class SquadHeader(unk1 : Int,
-                             unk2 : Boolean,
-                             unk3 : Option[Int],
-                             info : Option[SquadInfo] = None)
-
-/**
-  * An indexed entry in the listing of squads.<br>
-  * <br>
-  * Squad listing indices are not an arbitrary order.
-  * The server communicates changes to the client by referencing a squad's listing index, defined at the time of list initialization.
-  * Once initialized, each client may organize their squads however they wish, e.g., by leader, by task, etc., without compromising this index.
-  * During the list initialization process, the entries must always follow numerical order, increasing from `0`.
-  * During any other operation, the entries may be prefixed with whichever index is necessary to indicate the squad listing in question.
-  * @param index the index of this listing;
-  *              first entry should be 0, and subsequent valid entries are sequentially incremental;
-  *              last entry is always a placeholder with index 255
-  * @param listing the data for this entry, defining both the actions and the pertinent squad information
+  * An indexed entry in the listing of squads.
+  * @param index the listing entry index for this squad;
+  *              zero-based;
+  *              255 is the maximum index and is reserved to indicate the end of the listings for the packet
+  * @param listing the squad data;
+  *                `None` when the index is 255, or when invoking a "remove" action on any squad at a known index
   */
 final case class SquadListing(index : Int = 255,
-                              listing : Option[SquadHeader] = None)
+                              listing : Option[SquadInfo] = None)
 
 /**
-  * Modify the list of squads available to a given player.
-  * The squad list updates in real time rather than just whenever a player opens the squad information window.<br>
+  * Display the list of squads available to a given player.<br>
   * <br>
-  * The four main operations are: initializing the list, updating entries in the list, removing entries from the list, and clearing the list.
+  * The four main operations are:
+  * initializing the list,
+  * updating entries in the list,
+  * removing entries from the list,
+  * and clearing the list.
   * The process of initializing the list and clearing the list actually are performed by similar behavior.
   * Squads would just not be added after the list clears.
   * Moreover, removing entries from the list overrides the behavior to update entries in the list.
-  * The two-three codes per entry (see `SquadHeader`) are important for determining the effect of a specific entry.
-  * As of the moment, the important details of the behaviors is that they modify how the packet is encoded and padded.<br>
+  * Squad list entries are typically referenced by their line index.<br>
   * <br>
-  * Referring to information in `SquadListing`, entries are identified by their index in the list.
-  * This is followed by a coded section that indicates what action the entry will execute on that squad listing.
-  * After the "coded action" section is the "general information" section where the data for the change is specified.
-  * In this manner, all the entries will have a knowable length.<br>
-  * <br>
-  * The total number of entries in a packet is not known until they have all been parsed.
+  * Though often specified with a global identifier, squads are rarely accessed using that identifier.
+  * Outside of initialization activities, the specific index of the squad listing is referenced.
   * During the list initialization process, the entries must be in ascending order of index.
-  * Otherwise, the specific index of the squad listing is referenced.
+  * The total number of entries in a packet is not known until they have all been parsed.
   * The minimum number of entries is "no entries."
   * The maximum number of entries is supposedly 254.
   * The last item is always the index 255 and this is interpreted as the end of the stream.<br>
@@ -106,9 +98,10 @@ final case class SquadListing(index : Int = 255,
   * `5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; `Clear squad list and initialize new squad list<br>
   * `5&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; `Clear squad list (transitions directly into 255-entry)<br>
   * `6&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;X&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; `Update a squad in the list
-  * @param behavior a code that suggests the primary purpose of the data in this packet
-  * @param behavior2 during initialization, this code is read;
-  *                  it supplements the normal `behavior` and is typically is an "update" code
+  * @param behavior a required code that suggests the operations of the data in this packet
+  * @param behavior2 an optional code that suggests the operations of the data in this packet;
+  *                  during initialization, this code is read;
+  *                  it typically flags an "update" action
   * @param entries a `Vector` of the squad listings
   */
 final case class ReplicationStreamMessage(behavior : Int,
@@ -121,15 +114,20 @@ final case class ReplicationStreamMessage(behavior : Int,
 }
 
 object SquadInfo {
+  /**
+    * An entry where no fields are defined.
+    */
+  final val Blank = SquadInfo(None, None, None, None, None)
+
   /**
     * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the fields.<br>
     * <br>
     * This constructor is not actually used at the moment.
-    * @param leader the name of the squad leader
-    * @param task the task the squad is trying to perform
+    * @param leader         the name of the squad leader
+    * @param task           the task the squad is trying to perform
     * @param continent_guid the continent on which the squad is acting
-    * @param size the current size of the squad
-    * @param capacity the maximum number of members that the squad can tolerate
+    * @param size           the current size of the squad
+    * @param capacity       the maximum number of members that the squad can tolerate
     * @return a `SquadInfo` object
     */
   def apply(leader : String, task : String, continent_guid : PlanetSideZoneID, size : Int, capacity : Int) : SquadInfo = {
@@ -139,13 +137,13 @@ object SquadInfo {
   /**
     * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the fields.<br>
     * <br>
-    * This constructor is used by the `initCodec`, `alt_initCodec`, and `allCodec`.
-    * @param leader the name of the squad leader
-    * @param task the task the squad is trying to perform
+    * This constructor is used by the `infoCodec`, `alt_infoCodec`, and `allCodec`.
+    * @param leader         the name of the squad leader
+    * @param task           the task the squad is trying to perform
     * @param continent_guid the continent on which the squad is acting
-    * @param size the current size of the squad
-    * @param capacity the maximum number of members that the squad can tolerate
-    * @param squad_guid a GUID associated with the squad, used to recover the squad definition
+    * @param size           the current size of the squad
+    * @param capacity       the maximum number of members that the squad can tolerate
+    * @param squad_guid     a GUID associated with the squad, used to recover the squad definition
     * @return a `SquadInfo` object
     */
   def apply(leader : String, task : String, continent_guid : PlanetSideZoneID, size : Int, capacity : Int, squad_guid : PlanetSideGUID) : SquadInfo = {
@@ -153,33 +151,23 @@ object SquadInfo {
   }
 
   /**
-    * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the important field.<br>
-    * <br>
-    * This constructor is used by `leaderCodec`.
-    * Two of the fields normally are `Option[String]`s.
-    * Only the `leader` field in this packet is a `String`, giving the method a distinct signature.
-    * The other field - an `Option[String]` for `task` - can still be set if passed.<br>
-    * <br>
-    * Recommended use: `SquadInfo(leader, None)`
+    * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the important field.
     * @param leader the name of the squad leader
-    * @param task the task the squad is trying to perform, if not `None`
     * @return a `SquadInfo` object
     */
-  def apply(leader : String, task : Option[String]) : SquadInfo = {
-    SquadInfo(Some(leader), task, None, None, None)
+  def apply(leader : String) : SquadInfo = {
+    SquadInfo(Some(leader), None, None, None, None)
   }
 
   /**
     * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the important field.<br>
     * <br>
-    * This constructor is used by `taskOrContinentCodec`.
-    * Two of the fields normally are `Option[String]`s.
     * Only the `task` field in this packet is a `String`, giving the method a distinct signature.
     * The other field - an `Option[String]` for `leader` - can still be set if passed.<br>
     * <br>
     * Recommended use: `SquadInfo(None, task)`
     * @param leader the name of the squad leader, if not `None`
-    * @param task the task the squad is trying to perform
+    * @param task   the task the squad is trying to perform
     * @return a `SquadInfo` object
     */
   def apply(leader : Option[String], task : String) : SquadInfo = {
@@ -187,9 +175,7 @@ object SquadInfo {
   }
 
   /**
-    * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the field.<br>
-    * <br>
-    * This constructor is used by `taskOrContinentCodec`.
+    * Alternate constructor for `SquadInfo` that ignores the `Option` requirement for the field.
     * @param continent_guid the continent on which the squad is acting
     * @return a `SquadInfo` object
     */
